// Generated by CoffeeScript 1.3.1
(function() {
  var Backbone, Hash, Pill, Query, QueryCollection, exports, util, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor; child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  _ = (typeof window !== "undefined" && window !== null) && window._ || require('underscore');

  Backbone = (typeof window !== "undefined" && window !== null) && window.Backbone || require('backbone');

  util = {
    safeRegex: function(str) {
      return (str || '').replace('(.)', '\\$1');
    },
    createRegex: function(str) {
      return new RegExp(str, 'ig');
    },
    createSafeRegex: function(str) {
      return util.createRegex(util.safeRegex(str));
    },
    toArray: function(value) {
      var item, key, result;
      result = [];
      if (value) {
        if (_.isArray(value)) {
          result = value;
        } else if (_.isObject(value)) {
          for (key in value) {
            if (!__hasProp.call(value, key)) continue;
            item = value[key];
            result.push(item);
          }
        } else {
          result.push(value);
        }
      }
      return result;
    }
  };

  Hash = (function(_super) {

    __extends(Hash, _super);

    Hash.name = 'Hash';

    Hash.prototype.arr = [];

    function Hash(value) {
      var item, key, _i, _len;
      value = util.toArray(value);
      for (key = _i = 0, _len = value.length; _i < _len; key = ++_i) {
        item = value[key];
        this.push(item);
      }
    }

    Hash.prototype.hasIn = function(options) {
      var value, _i, _len;
      options = util.toArray(options);
      for (_i = 0, _len = this.length; _i < _len; _i++) {
        value = this[_i];
        if (__indexOf.call(options, value) >= 0) {
          return true;
        }
      }
      return false;
    };

    Hash.prototype.hasAll = function(options) {
      var empty, pass, value, _i, _len;
      options = util.toArray(options);
      empty = true;
      pass = true;
      for (_i = 0, _len = this.length; _i < _len; _i++) {
        value = this[_i];
        empty = false;
        if (__indexOf.call(options, value) < 0) {
          pass = false;
        }
      }
      if (empty) {
        pass = false;
      }
      return pass;
    };

    Hash.prototype.isSame = function(options) {
      var pass;
      options = util.toArray(options);
      pass = this.sort().join() === options.sort().join();
      return pass;
    };

    return Hash;

  })(Array);

  QueryCollection = (function(_super) {

    __extends(QueryCollection, _super);

    QueryCollection.name = 'QueryCollection';

    function QueryCollection() {
      return QueryCollection.__super__.constructor.apply(this, arguments);
    }

    QueryCollection.prototype.model = Backbone.Model;

    QueryCollection.prototype.initialize = function(models, options) {
      var _base;
      _.bindAll(this, 'onChange', 'onParentChange', 'onParentRemove', 'onParentAdd', 'onParentReset');
      this.options = _.extend({}, this.options || {}, options || {});
      this.options.filters = _.extend({}, this.options.filters || {});
      this.options.queries = _.extend({}, this.options.queries || {});
      this.options.pills = _.extend({}, this.options.pills || {});
      (_base = this.options).searchString || (_base.searchString = null);
      this.setFilters(this.options.filters);
      this.setQueries(this.options.queries);
      this.setPills(this.options.pills);
      this.setSearchString(this.options.searchString);
      this.live();
      return this;
    };

    QueryCollection.prototype.getFilter = function(key) {
      return this.options.filters[key];
    };

    QueryCollection.prototype.getFilters = function() {
      return this.options.filters;
    };

    QueryCollection.prototype.setFilters = function(filters) {
      var key, value;
      filters || (filters = {});
      for (key in filters) {
        if (!__hasProp.call(filters, key)) continue;
        value = filters[key];
        this.setFilter(key, value);
      }
      return this;
    };

    QueryCollection.prototype.setFilter = function(name, value) {
      var filters;
      filters = this.options.filters;
      if (value != null) {
        filters[name] = value;
      } else if (filters[name] != null) {
        delete filters[name];
      }
      return this;
    };

    QueryCollection.prototype.getQuery = function(key) {
      return this.options.queries[key];
    };

    QueryCollection.prototype.getQueries = function() {
      return this.options.queries;
    };

    QueryCollection.prototype.setQueries = function(queries) {
      var key, value;
      queries || (queries = {});
      for (key in queries) {
        if (!__hasProp.call(queries, key)) continue;
        value = queries[key];
        this.setQuery(key, value);
      }
      return this;
    };

    QueryCollection.prototype.setQuery = function(name, value) {
      var queries;
      queries = this.options.queries;
      if (value != null) {
        if (!(value instanceof Query)) {
          value = new Query(value);
        }
        queries[name] = value;
      } else if (queries[name] != null) {
        delete queries[name];
      }
      return this;
    };

    QueryCollection.prototype.getPill = function(key) {
      return this.options.pills[key];
    };

    QueryCollection.prototype.getPills = function() {
      return this.options.pills;
    };

    QueryCollection.prototype.setPills = function(pills) {
      var key, value;
      pills || (pills = {});
      for (key in pills) {
        if (!__hasProp.call(pills, key)) continue;
        value = pills[key];
        this.setPill(key, value);
      }
      return this;
    };

    QueryCollection.prototype.setPill = function(name, value) {
      var pills, searchString;
      pills = this.options.pills;
      searchString = this.options.searchString;
      if (value != null) {
        if (!(value instanceof Pill)) {
          value = new Pill(value);
        }
        if (searchString) {
          value.setSearchString(searchString);
        }
        pills[name] = value;
      } else if (pills[name] != null) {
        delete pills[name];
      }
      return this;
    };

    QueryCollection.prototype.getCleanedSearchString = function() {
      return this.options.cleanedSearchString;
    };

    QueryCollection.prototype.getSearchString = function() {
      return this.options.searchString;
    };

    QueryCollection.prototype.setSearchString = function(searchString) {
      var cleanedSearchString, pills;
      pills = this.options.pills;
      cleanedSearchString = searchString;
      _.each(pills, function(pill, pillName) {
        cleanedSearchString = pill.setSearchString(cleanedSearchString);
        return true;
      });
      this.options.searchString = searchString;
      this.options.cleanedSearchString = cleanedSearchString;
      return this;
    };

    QueryCollection.prototype.hasParentCollection = function() {
      return this.options.parentCollection != null;
    };

    QueryCollection.prototype.getParentCollection = function() {
      return this.options.parentCollection;
    };

    QueryCollection.prototype.setParentCollection = function(parentCollection, skipCheck) {
      if (!skipCheck && this.options.parentCollection === parentCollection) {
        return this;
      }
      this.options.parentCollection = parentCollection;
      this.live();
      return this;
    };

    QueryCollection.prototype.hasModel = function(model) {
      var exists;
      model || (model = {});
      if ((model.id != null) && this.get(model.id)) {
        exists = true;
      } else if ((model.cid != null) && this.getByCid(model.cid)) {
        exists = true;
      } else {
        exists = false;
      }
      return exists;
    };

    QueryCollection.prototype.safeRemove = function(model) {
      var exists;
      exists = this.hasModel(model);
      if (exists) {
        this.remove(model);
      }
      return this;
    };

    QueryCollection.prototype.safeAdd = function(model) {
      var exists;
      exists = this.hasModel(model);
      if (!exists) {
        this.add(model);
      }
      return this;
    };

    QueryCollection.prototype.sortArray = function(comparator) {
      var arr, key, value;
      arr = this.toJSON();
      if (comparator) {
        if (comparator instanceof Function) {
          arr.sort(comparator);
        } else if (comparator instanceof Object) {
          for (key in comparator) {
            if (!__hasProp.call(comparator, key)) continue;
            value = comparator[key];
            if (value === -1) {
              arr.sort(function(a, b) {
                return b[key] - a[key];
              });
            } else if (value === 1) {
              arr.sort(function(a, b) {
                return a[key] - b[key];
              });
            }
          }
        } else {
          throw new Error('Unknown comparator type was passed to QueryCollection::sortArray');
        }
      } else {
        if (this.comparator) {
          return this.sortArray(this.comparator);
        } else {
          throw new Error('Cannot sort a set without a comparator');
        }
      }
      return arr;
    };

    QueryCollection.prototype.query = function() {
      var collection, me, models;
      me = this;
      models = [];
      collection = this.getParentCollection() || this;
      collection.each(function(model) {
        var pass;
        pass = me.test(model);
        if (pass) {
          return models.push(model);
        }
      });
      this.reset(models);
      return this;
    };

    QueryCollection.prototype.createChildCollection = function() {
      var collection;
      collection = new QueryCollection().setParentCollection(this);
      return collection;
    };

    QueryCollection.prototype.createLiveChildCollection = function() {
      var collection;
      collection = this.createChildCollection().live(true);
      return collection;
    };

    QueryCollection.prototype.findAll = function(query) {
      var collection;
      collection = this.createChildCollection().setQuery('find', query).query();
      return collection;
    };

    QueryCollection.prototype.findOne = function(query) {
      var collection;
      collection = this.createChildCollection().setQuery('find', query).query();
      if (collection && collection.length) {
        return collection.models[0];
      } else {
        return null;
      }
    };

    QueryCollection.prototype.live = function(enabled) {
      var parentCollection;
      if (enabled == null) {
        enabled = this.options.live;
      }
      this.options.live = enabled;
      if (enabled) {
        this.on('change', this.onChange);
      } else {
        this.off('change', this.onChange);
      }
      parentCollection = this.getParentCollection();
      if (parentCollection != null) {
        if (enabled) {
          parentCollection.on('change', this.onParentChange);
          parentCollection.on('remove', this.onParentRemove);
          parentCollection.on('add', this.onParentAdd);
          parentCollection.on('reset', this.onParentReset);
        } else {
          parentCollection.off('change', this.onParentChange);
          parentCollection.off('remove', this.onParentRemove);
          parentCollection.off('add', this.onParentAdd);
          parentCollection.off('reset', this.onParentReset);
        }
      }
      return this;
    };

    QueryCollection.prototype.add = function(models, options) {
      var model, passedModels, _i, _len;
      options = options ? _.clone(options) : {};
      models = _.isArray(models) ? models.slice() : [models];
      passedModels = [];
      for (_i = 0, _len = models.length; _i < _len; _i++) {
        model = models[_i];
        model = this._prepareModel(model, options);
        if (model && this.test(model)) {
          passedModels.push(model);
        }
      }
      Backbone.Collection.prototype.add.apply(this, [passedModels, options]);
      return this;
    };

    QueryCollection.prototype.create = function(model, options) {
      options = options ? _.clone(options) : {};
      model = this._prepareModel(model, options);
      if (model && this.test(model)) {
        Backbone.Collection.prototype.create.apply(this, [model, options]);
      }
      return this;
    };

    QueryCollection.prototype.onChange = function(model) {
      var pass;
      pass = this.test(model);
      if (!pass) {
        this.safeRemove(model);
      }
      return this;
    };

    QueryCollection.prototype.onParentChange = function(model) {
      var pass;
      pass = this.test(model) && this.getParentCollection().test(model);
      if (pass) {
        this.safeAdd(model);
      } else {
        this.safeRemove(model);
      }
      return this;
    };

    QueryCollection.prototype.onParentRemove = function(model) {
      this.safeRemove(model);
      return this;
    };

    QueryCollection.prototype.onParentAdd = function(model) {
      this.safeAdd(model);
      return this;
    };

    QueryCollection.prototype.onParentReset = function(model) {
      this.reset(this.getParentCollection().models);
      return this;
    };

    QueryCollection.prototype.test = function(model) {
      var pass;
      pass = this.testFilters(model) && this.testQueries(model) && this.testPills(model);
      return pass;
    };

    QueryCollection.prototype.testFilters = function(model) {
      var cleanedSearchString, filters, pass;
      pass = true;
      cleanedSearchString = this.getCleanedSearchString();
      filters = this.getFilters();
      _.each(filters, function(filter, filterName) {
        if (filter(model, cleanedSearchString) === false) {
          pass = false;
          return false;
        }
      });
      return pass;
    };

    QueryCollection.prototype.testQueries = function(model) {
      var pass, queries;
      pass = true;
      queries = this.getQueries();
      _.each(queries, function(query, queryName) {
        if (query.test(model) === false) {
          pass = false;
          return false;
        }
      });
      return pass;
    };

    QueryCollection.prototype.testPills = function(model) {
      var pass, pills, searchString;
      pass = true;
      searchString = this.getSearchString();
      pills = this.getPills();
      if (searchString != null) {
        _.each(pills, function(pill, pillName) {
          if (pill.test(model) === false) {
            pass = false;
            return false;
          }
        });
      }
      return pass;
    };

    return QueryCollection;

  })(Backbone.Collection);

  Pill = (function() {

    Pill.name = 'Pill';

    Pill.prototype.callback = null;

    Pill.prototype.regex = null;

    Pill.prototype.prefixes = null;

    Pill.prototype.searchString = null;

    Pill.prototype.value = null;

    function Pill(pill) {
      var prefix, regexString, safePrefixes, safePrefixesStr, _i, _len, _ref;
      pill || (pill = {});
      this.callback = pill.callback;
      this.prefixes = pill.prefixes;
      safePrefixes = [];
      _ref = this.prefixes;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        prefix = _ref[_i];
        safePrefixes.push(util.safeRegex(prefix));
      }
      safePrefixesStr = safePrefixes.join('|');
      regexString = '(' + safePrefixesStr + ')([^\\s]+)';
      this.regex = util.createRegex(regexString);
      this;

    }

    Pill.prototype.setSearchString = function(searchString) {
      var cleanedSearchString, match, value;
      cleanedSearchString = searchString;
      value = null;
      while (match = this.regex.exec(searchString)) {
        value = match[2].trim();
        cleanedSearchString = searchString.replace(match[0], '').trim();
      }
      this.searchString = searchString;
      this.value = value;
      return cleanedSearchString;
    };

    Pill.prototype.test = function(model) {
      var pass;
      pass = null;
      if (this.value != null) {
        pass = this.callback(model, this.value);
      }
      return pass;
    };

    return Pill;

  })();

  Query = (function() {

    Query.name = 'Query';

    Query.prototype.query = null;

    function Query(query) {
      if (query == null) {
        query = {};
      }
      this.query = query;
    }

    Query.prototype.test = function(model) {
      var $beginsWith, $beginsWithValue, $endWithValue, $endsWith, empty, exists, field, id, match, matchAll, matchAny, query, selector, value, _i, _j, _k, _l, _len, _len1, _len2, _len3, _len4, _m, _ref;
      matchAll = true;
      matchAny = false;
      empty = true;
      _ref = this.query;
      for (field in _ref) {
        if (!__hasProp.call(_ref, field)) continue;
        selector = _ref[field];
        match = false;
        empty = false;
        value = model.get(field);
        id = model.get('id');
        exists = typeof value !== 'undefined';
        if (!exists) {
          value = false;
        }
        if (field === '$nor') {
          match = true;
          empty = true;
          for (_i = 0, _len = selector.length; _i < _len; _i++) {
            query = selector[_i];
            empty = false;
            query = new Query(query);
            if (query.test(model)) {
              match = false;
              break;
            }
          }
          if (empty) {
            match = true;
          }
        }
        if (field === '$or') {
          match = false;
          empty = true;
          for (_j = 0, _len1 = selector.length; _j < _len1; _j++) {
            query = selector[_j];
            empty = false;
            query = new Query(query);
            if (query.test(model)) {
              match = true;
              break;
            }
          }
          if (empty) {
            match = true;
          }
        }
        if (field === '$and') {
          match = true;
          for (_k = 0, _len2 = selector.length; _k < _len2; _k++) {
            query = selector[_k];
            query = new Query(query);
            if (!query.test(model)) {
              match = false;
            }
          }
        }
        if (_.isString(selector) || _.isNumber(selector)) {
          if (exists && value === selector) {
            match = true;
          }
        } else if (_.isArray(selector)) {
          if (exists && (new Hash(value)).isSame(selector)) {
            match = true;
          }
        } else if (_.isDate(selector)) {
          if (exists && value.toString() === selector.toString()) {
            match = true;
          }
        } else if (_.isRegExp(selector)) {
          if (exists && selector.test(value)) {
            match = true;
          }
        } else if (_.isObject(selector)) {
          $beginsWith = selector.$beginsWith || selector.$startsWith || null;
          if ($beginsWith && exists && _.isString(value)) {
            if (!_.isArray($beginsWith)) {
              $beginsWith = [$beginsWith];
            }
            for (_l = 0, _len3 = $beginsWith.length; _l < _len3; _l++) {
              $beginsWithValue = $beginsWith[_l];
              if (value.substr(0, $beginsWithValue.length) === $beginsWithValue) {
                match = true;
                break;
              }
            }
          }
          $endsWith = selector.$endsWith || selector.$finishesWith || null;
          if ($endsWith && exists && _.isString(value)) {
            if (!_.isArray($endsWith)) {
              $endsWith = [$endsWith];
            }
            for (_m = 0, _len4 = $endsWith.length; _m < _len4; _m++) {
              $endWithValue = $endsWith[_m];
              if (value.substr($endWithValue.length * -1) === $endWithValue) {
                match = true;
                break;
              }
            }
          }
          if (selector.$all) {
            if (exists) {
              if ((new Hash(value)).hasAll(selector.$all)) {
                match = true;
              }
            }
          }
          if (selector.$in) {
            if (exists) {
              if ((new Hash(value)).hasIn(selector.$in)) {
                match = true;
              } else if ((new Hash(selector.$in)).hasIn(value)) {
                match = true;
              }
            }
          }
          if (selector.$has) {
            if (exists) {
              if ((new Hash(value)).hasIn(selector.$has)) {
                match = true;
              }
            }
          }
          if (selector.$hasAll) {
            if (exists) {
              if ((new Hash(value)).hasIn(selector.$hasAll)) {
                match = true;
              }
            }
          }
          if (selector.$nin) {
            if (exists) {
              if ((new Hash(value)).hasIn(selector.$nin) === false && (new Hash(selector.$nin)).hasIn(value) === false) {
                match = true;
              }
            }
          }
          if (selector.$size) {
            if ((value.length != null) && value.length === selector.$size) {
              match = true;
            }
          }
          if (selector.$type) {
            if (typeof value === selector.$type) {
              match = true;
            }
          }
          if (selector.$exists) {
            if (selector.$exists) {
              if (exists === true) {
                match = true;
              }
            } else {
              if (exists === false) {
                match = true;
              }
            }
          }
          if (selector.$mod) {
            match = false;
          }
          if (selector.$ne) {
            if (exists && value !== selector.$ne) {
              match = true;
            }
          }
          if (selector.$lt) {
            if (exists && value < selector.$lt) {
              match = true;
            }
          }
          if (selector.$gt) {
            if (exists && value > selector.$gt) {
              match = true;
            }
          }
          if (selector.$lte) {
            if (exists && value <= selector.$lte) {
              match = true;
            }
          }
          if (selector.$gte) {
            if (exists && value >= selector.$gte) {
              match = true;
            }
          }
        }
        if (match) {
          matchAny = true;
        } else {
          matchAll = false;
        }
      }
      if (matchAll && !matchAny) {
        matchAll = false;
      }
      return matchAll;
    };

    return Query;

  })();

  exports = {
    safeRegex: util.safeRegex,
    createRegex: util.createRegex,
    createSafeRegex: util.createSafeRegex,
    toArray: util.toArray,
    Backbone: Backbone,
    Hash: Hash,
    QueryCollection: QueryCollection,
    Query: Query,
    Pill: Pill,
    createCollection: function(models, options) {
      var collection;
      models = util.toArray(models);
      collection = new QueryCollection(models, options);
      return collection;
    },
    createLiveCollection: function(models, options) {
      var collection;
      models = util.toArray(models);
      collection = new QueryCollection(models, options).live(true);
      return collection;
    }
  };

  if ((typeof module !== "undefined" && module !== null) && (module.exports != null)) {
    module.exports = exports;
  } else if (typeof window !== "undefined" && window !== null) {
    window.queryEngine = exports;
  }

}).call(this);
